#define banner "This is expr [11-Apr-1991], in CWEB\n"
/*4:*//*5:*/
#line 237 "expr2.w"
#if    __STDC__
#define ARGS(plist)             plist
#else
#define ARGS(parenthesized_list) ()
#endif/*:5*//*9:*/
#line 290 "expr2.w"
#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS 0
#endif/*:9*//*7:*/
#line 266 "expr2.w"
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <math.h>/*:7*//*8:*/
#line 276 "expr2.w"
#if    __STDC__
#include <stdlib.h>
#else
double strtod ARGS((const char*nptr,char* *endptr));
#endif/*:8*//*6:*/
#line 249 "expr2.w"
void error ARGS((void));
void expect ARGS((int c));
double expr ARGS((void));
double factor ARGS((void));
void initialize ARGS((void));
int nextnb ARGS((void));
#line 87 "expr2.ch"
int peeknb ARGS((void));
double power ARGS((void));
#line 256 "expr2.w"
double term ARGS((void));
int main ARGS((int argc,char*argv[]));/*:6*//*10:*/
#line 304 "expr2.w"
#define MAXBUF 10240/*:10*//*11:*/
#line 315 "expr2.w"
char buf[MAXBUF];char*pc;/*:11*//*13:*/
#line 335 "expr2.w"
int
main(argc,argv)
int argc;
char*argv[];
{
(void)printf(banner);/*14:*/
#line 347 "expr2.w"
(void)printf("expr>");

while(fgets(buf,MAXBUF,stdin)!=(char*)NULL)
{
initialize();
(void)printf("%lg\n",expr());
if(nextnb())
error();
(void)printf("expr>");
(void)fflush(stdout);
}/*:14*/
#line 342 "expr2.w"
exit(EXIT_SUCCESS);
return(EXIT_SUCCESS);
}/*:13*//*:4*//*15:*//*16:*/
#line 368 "expr2.w"
void
initialize()
{
pc=buf;
}/*:16*//*:15*//*17:*//*18:*/
#line 397 "expr2.w"
double
expr()
{
double e=term();

for(;;)
{
if(peeknb()=='+')
nextnb(),e+=term();
else if(peeknb()=='-')
nextnb(),e-=term();
else
return(e);
}
}/*:18*//*:17*//*19:*//*20:*/
#line 121 "expr2.ch"
double
power()
{
double p=factor();

for(;;)
{
if(peeknb()=='^')
nextnb(),p=pow(p,power());
else
return(p);
}
}/*:20*//*:19*//*21:*//*22:*/
#line 432 "expr2.w"
double
factor()
{
double e;
char*p;

if(peeknb()=='(')
{
nextnb();
e=expr();
expect(')');
}
else
{
e=strtod(pc,&p);
if(p==pc)
error();
else
pc=p;
}
return(e);
}/*:22*//*:21*//*23:*//*24:*/
#line 472 "expr2.w"
double
term()
{
#line 153 "expr2.ch"
double t=power();
#line 477 "expr2.w"
for(;;)
{
#line 162 "expr2.ch"
if(peeknb()=='*')
nextnb(),t*=power();
else if(peeknb()=='/')
nextnb(),t/=power();
#line 483 "expr2.w"
else
return(t);
}
}/*:24*//*:23*//*25:*/
#line 496 "expr2.w"
void
expect(c)
int c;
{
if(nextnb()!=c)
error();
}/*:25*//*26:*//*27:*/
#line 520 "expr2.w"
int
nextnb()
{
while(*pc&&isspace(*pc))
++pc;
return(*pc? *pc++:*pc);

}/*:27*//*:26*//*28:*//*29:*/
#line 543 "expr2.w"
int
peeknb()
{
int c=nextnb();

pc--;
return(c);
}/*:29*//*:28*//*30:*//*31:*/
#line 568 "expr2.w"
void
error()
{
(void)fprintf(stderr,
"? Error: remaining text = [%s]\n",pc);
*pc='\0';
}/*:31*//*:30*/
