# /u/sy/beebe/src/lex/qtoddtoq/fmtfun.awk, Tue Apr 27 11:09:33 1993
# Edit by Nelson H. F. Beebe <beebe@plot79.math.utah.edu>
# ========================================================================
# Convert a table of pairs of function names (quad and double) to
# rule lines for the lex file, qtod.l.
# Usage:
#	nawk -f fmtfun.awk fmtfun.names
# [27-Apr-1993]
# ========================================================================
{
    if (NF == 2)
    {
	brace($1)
	print "\t\tcvtstr(\"" $2 "\");"
    }
}

function brace(s, c)
{
    for (k = 1; k <= length(s); ++k)
    {
	c = substr(s,k,1)
	if (islower(c))
	    printf("{%s}",c)
        else
	    printf("%s",c)
    }
    printf("/{W}\"(\"");
}

function islower(c)
{
    return (("a" <= c) && (c <= "z"))
}
