.TH WF 1L "08 April 1991"
.\"======================================================================
.SH "NAME"
wf \- word frequency
.\"======================================================================
.SH "SYNOPSIS"
.B wf
< infile >outfile
.PP
.B wf
filters its standard input, printing on standard output a list of
(frequency, word) pairs, one per line, sorted in order of descending
frequency.  Words with the same frequency are displayed in
alphabetical order.
.PP
A 
.I word
starts with a letter or underscore, and is followed by zero or more
letters, underscores, or digits.  Letter case is ignored.
.PP
This is a handy tool for analyzing writing vocabulary.
.PP
Its other purpose is to demonstrate a modest
.BR lex (1)
program and hashing techniques.
.\"======================================================================
.SH "SEE ALSO"
.BR awk (1),
.BR lex (1).
.\"======================================================================
.SH "AUTHOR"
Nelson H. F. Beebe, Ph.D.
.br
Center for Scientific Computing
.br
Department of Mathematics
.br
South Physics Building
.br
University of Utah
.br
Salt Lake City, UT 84112
.br
Tel: (801) 581-5254
.br
FAX: (801) 581-4148
.br
Email: <beebe@science.utah.edu>
.\"==============================[The End]==============================
